com.fasterxml.jackson.databind.deser.std

## Class ReferenceTypeDeserializer<T>

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.ReferenceTypeDeserializer<T>

- All Implemented Interfaces:
    ContextualDeserializer, NullValueProvider, Serializable
  Direct Known Subclasses:
    AtomicReferenceDeserializer

      public abstract class ReferenceTypeDeserializer<T>
      extends StdDeserializer<T>
      implements ContextualDeserializer

  Base deserializer implementation for properties `ReferenceType` values. Implements most of functionality, only leaving couple of abstract methods for sub-classes to implement
  Since:
    2.8
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JavaType` | `_fullType` Full type of property (or root value) for which this deserializer has been constructed and contextualized.
    `protected JsonDeserializer<Object>` | `_valueDeserializer`
    `protected ValueInstantiator` | `_valueInstantiator`
    `protected TypeDeserializer` | `_valueTypeDeserializer`

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass, _valueType, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ReferenceTypeDeserializer(JavaType fullType, TypeDeserializer typeDeser, JsonDeserializer<?> deser)` Deprecated.
    `ReferenceTypeDeserializer(JavaType fullType, ValueInstantiator vi, TypeDeserializer typeDeser, JsonDeserializer<?> deser)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `JsonDeserializer<?>` | `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property.
    `T` | `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `T` | `deserialize(JsonParser p, DeserializationContext ctxt, T reference)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
    `Object` | `deserializeWithType(JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
    `AccessPattern` | `getEmptyAccessPattern()` This method may be called in conjunction with calls to `JsonDeserializer.getEmptyValue(DeserializationContext)`, to check whether it needs to be called just once (static values), or each time empty value is needed.
    `Object` | `getEmptyValue(DeserializationContext ctxt)` Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings).
    `AccessPattern` | `getNullAccessPattern()` Null value varies dynamically (unlike with scalar types), so let's indicate this.
    `abstract T` | `getNullValue(DeserializationContext ctxt)` Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`).
    `abstract Object` | `getReferenced(T reference)` Method that may be called to find contents of specified reference, if any; or `null` if none.
    `JavaType` | `getValueType()` Exact structured type this deserializer handles, if known.
    `abstract T` | `referenceValue(Object contents)`
    `Boolean` | `supportsUpdate(DeserializationConfig config)` By default we assume that updateability mostly relies on value deserializer; if it supports updates, typically that's what matters.
    `abstract T` | `updateReference(T reference, Object contents)` Method called in case of "merging update", in which we should try update reference instead of creating a new one.
    `protected abstract ReferenceTypeDeserializer<T>` | `withResolved(TypeDeserializer typeDeser, JsonDeserializer<?> valueDeser)` Mutant factory method called when changes are needed; should construct newly configured instance with new values as indicated.

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_byteOverflow, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeWrappedValue, _failDoubleToIntCoercion, _findNullProvider, _hasTextualNull, _intOverflow, _isEmptyOrTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _neitherNull, _nonNullNumber, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseIntPrimitive, _parseIntPrimitive, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _reportFailedNullCoerce, _shortOverflow, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueType, handledType, handleMissingEndArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `deserializeWithType, findBackReference, getDelegatee, getEmptyValue, getKnownPropertyNames, getNullValue, getObjectIdReader, isCachable, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _fullType

          protected final JavaType _fullType

      Full type of property (or root value) for which this deserializer has been constructed and contextualized.

    - #### _valueInstantiator

          protected final ValueInstantiator _valueInstantiator

    - #### _valueTypeDeserializer

          protected final TypeDeserializer _valueTypeDeserializer

    - #### _valueDeserializer

          protected final JsonDeserializer<Object> _valueDeserializer

  - ### Constructor Detail

    - #### ReferenceTypeDeserializer

          public ReferenceTypeDeserializer(JavaType fullType,
                                           ValueInstantiator vi,
                                           TypeDeserializer typeDeser,
                                           JsonDeserializer<?> deser)

    - #### ReferenceTypeDeserializer

          @Deprecated
          public ReferenceTypeDeserializer(JavaType fullType,
                                                       TypeDeserializer typeDeser,
                                                       JsonDeserializer<?> deser)

      Deprecated.

  - ### Method Detail

    - #### createContextual

          public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                                      BeanProperty property)
                                               throws JsonMappingException

      Description copied from interface: `ContextualDeserializer`
      Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.
      Specified by:
        `createContextual` in interface `ContextualDeserializer`
      Parameters:
        `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
        `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
      Returns:
        Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### getNullAccessPattern

          public AccessPattern getNullAccessPattern()

      Null value varies dynamically (unlike with scalar types), so let's indicate this.
      Specified by:
        `getNullAccessPattern` in interface `NullValueProvider`
      Overrides:
        `getNullAccessPattern` in class `JsonDeserializer<T>`

    - #### getEmptyAccessPattern

          public AccessPattern getEmptyAccessPattern()

      Description copied from class: `JsonDeserializer`
      This method may be called in conjunction with calls to `JsonDeserializer.getEmptyValue(DeserializationContext)`, to check whether it needs to be called just once (static values), or each time empty value is needed.
      Overrides:
        `getEmptyAccessPattern` in class `JsonDeserializer<T>`

    - #### withResolved

          protected abstract ReferenceTypeDeserializer<T> withResolved(TypeDeserializer typeDeser,
                                                                       JsonDeserializer<?> valueDeser)

      Mutant factory method called when changes are needed; should construct newly configured instance with new values as indicated.

      NOTE: caller has verified that there are changes, so implementations need NOT check if a new instance is needed.

    - #### getNullValue

          public abstract T getNullValue(DeserializationContext ctxt)
                                  throws JsonMappingException

      Description copied from class: `JsonDeserializer`
      Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`). Usually this is simply Java null, but for some types (especially primitives) it may be necessary to use non-null values.

      This method may be called once, or multiple times, depending on what `JsonDeserializer.getNullAccessPattern()` returns.

      Default implementation simply returns null.

      Specified by:
        `getNullValue` in interface `NullValueProvider`
      Overrides:
        `getNullValue` in class `JsonDeserializer<T>`
      Throws:
        `JsonMappingException`

    - #### getEmptyValue

          public Object getEmptyValue(DeserializationContext ctxt)
                               throws JsonMappingException

      Description copied from class: `JsonDeserializer`
      Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings). Usually this is same as `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` (which in turn is usually simply Java null), but it can be overridden for specific types. Or, if type should never be converted from empty String, method can also throw an exception.

      This method may be called once, or multiple times, depending on what `JsonDeserializer.getEmptyAccessPattern()` returns.

      Default implementation simply calls `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` and returns value.

      Overrides:
        `getEmptyValue` in class `JsonDeserializer<T>`
      Throws:
        `JsonMappingException`

    - #### referenceValue

          public abstract T referenceValue(Object contents)

    - #### updateReference

          public abstract T updateReference(T reference,
                                            Object contents)

      Method called in case of "merging update", in which we should try update reference instead of creating a new one. If this does not succeed, should just create a new instance.
      Since:
        2.9

    - #### getReferenced

          public abstract Object getReferenced(T reference)

      Method that may be called to find contents of specified reference, if any; or `null` if none. Note that method should never fail, so for types that use concept of "absence" vs "presence", `null` is to be returned for both "absent" and "reference to `null`" cases.
      Since:
        2.9

    - #### getValueType

          public JavaType getValueType()

      Description copied from class: `StdDeserializer`
      Exact structured type this deserializer handles, if known.
      Overrides:
        `getValueType` in class `StdDeserializer<T>`

    - #### supportsUpdate

          public Boolean supportsUpdate(DeserializationConfig config)

      By default we assume that updateability mostly relies on value deserializer; if it supports updates, typically that's what matters. So let's just delegate.
      Overrides:
        `supportsUpdate` in class `JsonDeserializer<T>`

    - #### deserialize

          public T deserialize(JsonParser p,
                               DeserializationContext ctxt)
                        throws IOException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

      The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

                {
                    "@class": "class name",
                    ...
                }

      Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

                 if (p.currentToken() == JsonToken.START_OBJECT) {
                   p.nextToken();
                 }

      This results in the stream pointing to the field name, so that the two conditions align.

      Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<T>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `IOException`

    - #### deserialize

          public T deserialize(JsonParser p,
                               DeserializationContext ctxt,
                               T reference)
                        throws IOException

      Description copied from class: `JsonDeserializer`
      Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used (or supported) by all types (it will not work for immutable types, for obvious reasons): most commonly it is used for Collections and Maps. It may be used both with "updating readers" (for POJOs) and when Collections and Maps use "getter as setter".

      Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

      Overrides:
        `deserialize` in class `JsonDeserializer<T>`
      Throws:
        `IOException`

    - #### deserializeWithType

          public Object deserializeWithType(JsonParser p,
                                            DeserializationContext ctxt,
                                            TypeDeserializer typeDeserializer)
                                     throws IOException

      Description copied from class: `StdDeserializer`
      Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.
      Overrides:
        `deserializeWithType` in class `StdDeserializer<T>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `IOException`

Copyright © 2008–2020 FasterXML. All rights reserved.